/*
 * The Pipelined Regular Expression Monitor Compiler System
 * Copyright (c) 2002 University of British Columbia
 * All Rights Reserved.
 *
 *
 * BDD functions
 *
 * Marcio Oliveira -- 2002
 */

#ifndef DD_H
#define DD_H

#include <util.h>
#include <cudd.h>

DdManager *bddInit();
DdNode *bddAnd(DdManager *, DdNode *, DdNode *);
DdNode *bddOr(DdManager *, DdNode *, DdNode *);
DdNode *bddNot(DdNode *);
DdNode *bddOne(DdManager *);
DdNode *bddZero(DdManager *);
DdNode *bddNewVar(DdManager *);
DdNode *bddCompose(DdManager *, DdNode *, DdNode *, DdNode *);
DdNode *bddElse(DdManager *, DdNode *);
DdNode *bddThen(DdManager *, DdNode *);
DdNode *bddEquiv(DdManager *, DdNode *, DdNode *);
DdNode *bddEquivArray(DdManager *, DdNode **, DdNode **, int);
void bddFree(DdManager *ddm, DdNode *f);

#endif
