/*
 * The Pipelined Regular Expression Monitor Compiler System
 * Copyright (c) 2002 University of British Columbia
 * All Rights Reserved.
 *
 *
 * Hash table functions 
 *
 * Marcio Oliveira -- 2002
 */

#ifndef HASH_H
#define HASH_H

typedef struct hashTableEntry *hashTableEntryPtr;
struct hashTableEntry {
    char *key;
    void *value;
    hashTableEntryPtr next;
};

typedef struct hashTable *hashTablePtr;
struct hashTable {
    int size;
    hashTableEntryPtr *data;
};

hashTablePtr createHashTable(int);
int insertHashTableEntry(hashTablePtr, 
                         int (*)(void *, int), 
                         int (*)(void *, void *),
                         void *, 
                         void *);
int removeHashTableEntry(hashTablePtr, 
                         int (*)(void *, int),
                         int (*)(void *, void *),
                         void *);
int lookupHashTableEntry(hashTablePtr, 
                         int (*)(void *, int),
                         int (*)(void *, void *),
                         void *, 
                         void **);
hashTableEntryPtr getHashTableEntryArray(hashTablePtr);
int strHash(void *, int);
int intHash(void *, int);
int strCompare(void *, void *);
int intCompare(void *, void *);

#endif
